--- old/exception_lists/closed-bins	Sun Apr 12 08:56:09 2015
+++ new/exception_lists/closed-bins	Sun Apr 12 08:56:09 2015
@@ -41,6 +41,9 @@
 ./usr/has/bin
 ./usr/has/bin/patch
 ./usr/include/sys/pcmcia
+./usr/include/sys/usb/clients/hwarc
+./usr/include/sys/uwb
+./usr/include/sys/uwb/uwba
 ./usr/kernel
 ./usr/kernel/strmod
 ./usr/kernel/strmod/amd64
--- old/usr/src/Makefile.lint	Sun Apr 12 08:56:09 2015
+++ new/usr/src/Makefile.lint	Sun Apr 12 08:56:09 2015
@@ -25,6 +25,7 @@
 # Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2012 by Delphix. All rights reserved.
 # Copyright 2015 Nexenta Systems, Inc. All rights reserved.
+# Copyright 2015 Garrett D'Amore <garrett@damore.org>
 
 # include global definitions
 include Makefile.master
@@ -318,7 +319,6 @@
 	cmd/who \
 	cmd/whodo \
 	cmd/wracct \
-	cmd/wusbadm \
 	cmd/xargs \
 	cmd/xstr \
 	cmd/yes \
--- old/usr/src/cmd/Makefile	Sun Apr 12 08:56:09 2015
+++ new/usr/src/cmd/Makefile	Sun Apr 12 08:56:09 2015
@@ -448,7 +448,6 @@
 	whodo		\
 	wracct		\
 	write		\
-	wusbadm		\
 	xargs		\
 	xstr		\
 	yes		\
@@ -724,7 +723,6 @@
 	whodo		\
 	wracct		\
 	write		\
-	wusbadm		\
 	xargs		\
 	yppasswd	\
 	zdump		\
--- old/usr/src/man/man1m/Makefile	Sun Apr 12 08:56:10 2015
+++ new/usr/src/man/man1m/Makefile	Sun Apr 12 08:56:10 2015
@@ -565,7 +565,6 @@
 		wificonfig.1m		\
 		wpad.1m			\
 		wracct.1m		\
-		wusbadm.1m		\
 		ypbind.1m		\
 		ypinit.1m		\
 		ypmake.1m		\
--- old/usr/src/man/man7d/Makefile	Sun Apr 12 08:56:10 2015
+++ new/usr/src/man/man7d/Makefile	Sun Apr 12 08:56:10 2015
@@ -58,8 +58,6 @@
 		hid.7d		\
 		hme.7d		\
 		hubd.7d		\
-		hwahc.7d	\
-		hwarc.7d	\
 		hxge.7d		\
 		ib.7d		\
 		ibcm.7d		\
@@ -141,13 +139,10 @@
 		usbsksp.7d	\
 		usbsprl.7d	\
 		usbvc.7d	\
-		uwba.7d		\
 		virtualkm.7d	\
 		vni.7d		\
 		vr.7d		\
 		wscons.7d	\
-		wusb_ca.7d	\
-		wusb_df.7d	\
 		xge.7d		\
 		yge.7d		\
 		zcons.7d	\
@@ -247,7 +242,6 @@
 	 	bscbus.7d	\
 	 	fdc.7d		\
 	 	firewire.7d	\
-	 	hwa1480_fw.7d	\
 	 	i2bsc.7d	\
 	 	kmem.7d		\
 	 	lo0.7d		\
@@ -254,8 +248,7 @@
 	 	ticots.7d	\
 	 	ticotsord.7d	\
 	 	urandom.7d	\
-	 	usb.7d		\
-	 	uwb.7d
+	 	usb.7d
 
 sparc_MANLINKS=	drmach.7d	\
 		ngdr.7d		\
@@ -288,10 +281,6 @@
 
 usb.7d		:= LINKSRC = usba.7d
 
-uwb.7d		:= LINKSRC = uwba.7d
-
-hwa1480_fw.7d	:= LINKSRC = wusb_df.7d
-
 .KEEP_STATE:
 
 include		$(SRC)/man/Makefile.man
--- old/usr/src/pkg/manifests/SUNWcs.man1m.inc	Sun Apr 12 08:56:10 2015
+++ new/usr/src/pkg/manifests/SUNWcs.man1m.inc	Sun Apr 12 08:56:11 2015
@@ -276,7 +276,6 @@
 file path=usr/share/man/man1m/wall.1m
 file path=usr/share/man/man1m/whodo.1m
 file path=usr/share/man/man1m/wracct.1m
-file path=usr/share/man/man1m/wusbadm.1m
 file path=usr/share/man/man1m/zdump.1m
 file path=usr/share/man/man1m/zic.1m
 link path=usr/share/man/man1m/dcopy.1m target=clri.1m
--- old/usr/src/pkg/manifests/SUNWcs.mf	Sun Apr 12 08:56:11 2015
+++ new/usr/src/pkg/manifests/SUNWcs.mf	Sun Apr 12 08:56:11 2015
@@ -23,6 +23,7 @@
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2015 Nexenta Systems, Inc. All rights reserved.
 # Copyright (c) 2013 Gary Mills
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 <include SUNWcs.man1.inc>
@@ -664,7 +665,6 @@
 file path=sbin/umount mode=0555
 file path=sbin/umountall group=sys mode=0555
 file path=sbin/uname mode=0555
-file path=sbin/wusbadm mode=0555
 file path=sbin/zonename mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/amt mode=0555
 file path=usr/bin/$(ARCH32)/decrypt mode=0555
@@ -1785,7 +1785,6 @@
 link path=usr/lib/rsh target=../bin/ksh93
 link path=usr/lib/secure/32 target=.
 link path=usr/lib/secure/64 target=$(ARCH64)
-link path=usr/lib/wusbd target=../../sbin/wusbadm
 link path=usr/mail target=../var/mail
 link path=usr/net/nls/listen target=../../lib/saf/listen
 link path=usr/net/nls/nlps_server target=../../lib/saf/nlps_server
@@ -1838,7 +1837,6 @@
 link path=usr/sbin/ufsdump target=../lib/fs/ufs/ufsdump
 link path=usr/sbin/ufsrestore target=../lib/fs/ufs/ufsrestore
 link path=usr/sbin/umount target=../../sbin/umount
-link path=usr/sbin/wusbadm target=../../sbin/wusbadm
 link path=usr/spool target=../var/spool
 link path=usr/src target=./share/src
 link path=usr/tmp target=../var/tmp
--- old/usr/src/pkg/manifests/driver-usb.mf	Sun Apr 12 08:56:11 2015
+++ new/usr/src/pkg/manifests/driver-usb.mf	Sun Apr 12 08:56:11 2015
@@ -22,6 +22,7 @@
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 #
@@ -61,8 +62,6 @@
 driver name=ehci alias=pciclass,0c0320 perms="* 0644 root sys"
 driver name=hid alias=usbif,class3 perms="* 0600 root sys"
 driver name=hubd alias=usbif,class9 perms="* 0644 root sys"
-driver name=hwahc alias=usbif,classe0.2.1 perms="* 0644 root sys"
-driver name=hwarc alias=usbif,classe0.1.2 perms="* 0644 root sys"
 driver name=ohci alias=pciclass,0c0310 perms="* 0644 root sys"
 driver name=scsa2usb \
     alias=usb584,222 \
@@ -73,17 +72,11 @@
 driver name=usb_ia alias=usb,ia
 driver name=usb_mid alias=usb,device
 driver name=usbprn alias=usbif,class7.1 perms="* 0666 root sys"
-driver name=wusb_ca alias=usbif,classef.3.1 perms="* 0666 root sys"
-driver name=wusb_df perms="* 0666 root sys" \
-    alias=usb15a9,5 \
-    alias=usb3495,3007
 file path=etc/usb/config_map.conf group=sys \
     original_name=SUNWusb:etc/usb/config_map.conf preserve=true
 file path=kernel/drv/$(ARCH64)/ehci group=sys
 file path=kernel/drv/$(ARCH64)/hid group=sys
 file path=kernel/drv/$(ARCH64)/hubd group=sys
-file path=kernel/drv/$(ARCH64)/hwahc group=sys
-file path=kernel/drv/$(ARCH64)/hwarc group=sys
 file path=kernel/drv/$(ARCH64)/ohci group=sys
 file path=kernel/drv/$(ARCH64)/scsa2usb group=sys
 file path=kernel/drv/$(ARCH64)/uhci group=sys
@@ -92,14 +85,10 @@
 file path=kernel/drv/$(ARCH64)/usb_ia group=sys
 file path=kernel/drv/$(ARCH64)/usb_mid group=sys
 file path=kernel/drv/$(ARCH64)/usbprn group=sys
-file path=kernel/drv/$(ARCH64)/wusb_ca group=sys
-file path=kernel/drv/$(ARCH64)/wusb_df group=sys
 $(i386_ONLY)file path=kernel/drv/ehci group=sys
 file path=kernel/drv/ehci.conf group=sys
 $(i386_ONLY)file path=kernel/drv/hid group=sys
 $(i386_ONLY)file path=kernel/drv/hubd group=sys
-$(i386_ONLY)file path=kernel/drv/hwahc group=sys
-$(i386_ONLY)file path=kernel/drv/hwarc group=sys
 $(i386_ONLY)file path=kernel/drv/ohci group=sys
 file path=kernel/drv/ohci.conf group=sys
 $(i386_ONLY)file path=kernel/drv/scsa2usb group=sys
@@ -113,14 +102,10 @@
 $(i386_ONLY)file path=kernel/drv/usb_ia group=sys
 $(i386_ONLY)file path=kernel/drv/usb_mid group=sys
 $(i386_ONLY)file path=kernel/drv/usbprn group=sys
-$(i386_ONLY)file path=kernel/drv/wusb_ca group=sys
-$(i386_ONLY)file path=kernel/drv/wusb_df group=sys
 file path=kernel/misc/$(ARCH64)/hidparser group=sys mode=0755
-file path=kernel/misc/$(ARCH64)/hwa1480_fw group=sys mode=0755
 file path=kernel/misc/$(ARCH64)/usba group=sys mode=0755
 file path=kernel/misc/$(ARCH64)/usba10 group=sys mode=0755
 $(i386_ONLY)file path=kernel/misc/hidparser group=sys mode=0755
-$(i386_ONLY)file path=kernel/misc/hwa1480_fw group=sys mode=0755
 $(i386_ONLY)file path=kernel/misc/usba group=sys mode=0755
 $(i386_ONLY)file path=kernel/misc/usba10 group=sys mode=0755
 file path=kernel/strmod/$(ARCH64)/usb_ah group=sys mode=0755
@@ -131,13 +116,9 @@
 $(i386_ONLY)file path=kernel/strmod/usbkbm group=sys mode=0755
 $(i386_ONLY)file path=kernel/strmod/usbms group=sys mode=0755
 $(i386_ONLY)file path=kernel/strmod/usbwcm group=sys mode=0755
-file path=lib/svc/manifest/system/wusb.xml group=sys mode=0444
-file path=lib/svc/method/svc-wusb mode=0555
 file path=usr/share/man/man7d/ehci.7d
 file path=usr/share/man/man7d/hid.7d
 file path=usr/share/man/man7d/hubd.7d
-file path=usr/share/man/man7d/hwahc.7d
-file path=usr/share/man/man7d/hwarc.7d
 file path=usr/share/man/man7d/ohci.7d
 file path=usr/share/man/man7d/scsa2usb.7d
 file path=usr/share/man/man7d/uhci.7d
@@ -147,8 +128,6 @@
 file path=usr/share/man/man7d/usb_mid.7d
 file path=usr/share/man/man7d/usba.7d
 file path=usr/share/man/man7d/usbprn.7d
-file path=usr/share/man/man7d/wusb_ca.7d
-file path=usr/share/man/man7d/wusb_df.7d
 file path=usr/share/man/man7m/usb_ah.7m
 file path=usr/share/man/man7m/usbkbm.7m
 file path=usr/share/man/man7m/usbms.7m
@@ -200,9 +179,6 @@
 license cr_Sun license=cr_Sun
 license lic_CDDL license=lic_CDDL
 license license_in_headers license=license_in_headers
-license usr/src/uts/common/io/usb/clients/hwa1480_fw/i1480/LICENSE \
-    license=usr/src/uts/common/io/usb/clients/hwa1480_fw/i1480/LICENSE
-link path=usr/share/man/man7d/hwa1480_fw.7d target=wusb_df.7d
 link path=usr/share/man/man7d/usb.7d target=usba.7d
 link path=usr/share/man/man9f/usb_alloc_bulk_req.9f \
     target=usb_alloc_request.9f
--- old/usr/src/pkg/manifests/system-header-header-usb.mf	Sun Apr 12 08:56:11 2015
+++ new/usr/src/pkg/manifests/system-header-header-usb.mf	Sun Apr 12 08:56:11 2015
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 set name=pkg.fmri value=pkg:/system/header/header-usb@$(PKGVERS)
@@ -36,7 +37,6 @@
 dir path=usr/include/sys/usb/clients
 dir path=usr/include/sys/usb/clients/audio
 dir path=usr/include/sys/usb/clients/hid
-dir path=usr/include/sys/usb/clients/hwarc
 dir path=usr/include/sys/usb/clients/mass_storage
 dir path=usr/include/sys/usb/clients/printer
 dir path=usr/include/sys/usb/clients/usbcdc
@@ -45,11 +45,8 @@
 dir path=usr/include/sys/usb/clients/video
 dir path=usr/include/sys/usb/clients/video/usbvc
 dir path=usr/include/sys/usb/hubd
-dir path=usr/include/sys/uwb
-dir path=usr/include/sys/uwb/uwba
 file path=usr/include/sys/usb/clients/audio/usb_audio.h
 file path=usr/include/sys/usb/clients/hid/hid.h
-file path=usr/include/sys/usb/clients/hwarc/hwarc.h
 file path=usr/include/sys/usb/clients/mass_storage/usb_bulkonly.h
 file path=usr/include/sys/usb/clients/mass_storage/usb_cbi.h
 file path=usr/include/sys/usb/clients/printer/usb_printer.h
@@ -60,9 +57,6 @@
 file path=usr/include/sys/usb/usba.h
 file path=usr/include/sys/usb/usbai.h
 file path=usr/include/sys/usb/usbdevs.h
-file path=usr/include/sys/uwb/uwb.h
-file path=usr/include/sys/uwb/uwba/uwba.h
-file path=usr/include/sys/uwb/uwbai.h
 legacy pkg=SUNWusbu desc="USB Headers" name="USB Headers"
 license cr_Sun license=cr_Sun
 license lic_CDDL license=lic_CDDL
--- old/usr/src/pkg/manifests/system-kernel-ultra-wideband.mf	Sun Apr 12 08:56:11 2015
+++ new/usr/src/pkg/manifests/system-kernel-ultra-wideband.mf	Sun Apr 12 08:56:11 2015
@@ -22,6 +22,7 @@
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 #
@@ -31,21 +32,5 @@
 #
 <include global_zone_only_component>
 set name=pkg.fmri value=pkg:/system/kernel/ultra-wideband@$(PKGVERS)
-set name=pkg.description value="Common framework for UWB device drivers"
-set name=pkg.summary value="Ultra Wideband (UWB) support modules"
-set name=info.classification \
-    value=org.opensolaris.category.2008:System/Hardware
+set name=pkg.obsolete value=true
 set name=variant.arch value=$(ARCH)
-dir path=kernel group=sys
-dir path=kernel/misc group=sys
-dir path=kernel/misc/$(ARCH64) group=sys
-dir path=usr/share/man
-dir path=usr/share/man/man7d
-file path=kernel/misc/$(ARCH64)/uwba group=sys mode=0755
-$(i386_ONLY)file path=kernel/misc/uwba group=sys mode=0755
-file path=usr/share/man/man7d/uwba.7d
-legacy pkg=SUNWuwb desc="Common framework for UWB device drivers" \
-    name="Ultra Wideband (UWB) support modules"
-license cr_Sun license=cr_Sun
-license lic_CDDL license=lic_CDDL
-link path=usr/share/man/man7d/uwb.7d target=uwba.7d
--- old/usr/src/uts/common/Makefile.files	Sun Apr 12 08:56:11 2015
+++ new/usr/src/uts/common/Makefile.files	Sun Apr 12 08:56:11 2015
@@ -756,8 +756,6 @@
 
 HID_OBJS += hid.o
 
-HWA_RC_OBJS += hwarc.o
-
 USBSKEL_OBJS += usbskel.o
 
 USBVC_OBJS += usbvc.o usbvc_v4l2.o
@@ -786,8 +784,6 @@
 
 USBSPRL_OBJS += usbser_pl2303.o pl2303_dsd.o
 
-WUSB_CA_OBJS += wusb_ca.o
-
 USBFTDI_OBJS += usbser_uftdi.o uftdi_dsd.o
 
 USBECM_OBJS += usbecm.o
@@ -823,9 +819,6 @@
 
 USBA_OBJS +=	hcdi.o	usba.o	usbai.o hubdi.o parser.o genconsole.o \
 		usbai_pipe_mgmt.o usbai_req.o usbai_util.o usbai_register.o \
-		usba_devdb.o usba10_calls.o usba_ugen.o whcdi.o wa.o
-USBA_WITHOUT_WUSB_OBJS +=	hcdi.o	usba.o	usbai.o hubdi.o parser.o genconsole.o \
-		usbai_pipe_mgmt.o usbai_req.o usbai_util.o usbai_register.o \
 		usba_devdb.o usba10_calls.o usba_ugen.o
 
 USBA10_OBJS +=	usba10.o
@@ -1741,15 +1734,8 @@
 
 USB_IA_OBJS += usb_ia.o
 
-UWBA_OBJS += uwba.o uwbai.o
-
 SCSA2USB_OBJS += scsa2usb.o usb_ms_bulkonly.o usb_ms_cbi.o
 
-HWAHC_OBJS += hwahc.o hwahc_util.o
-
-WUSB_DF_OBJS += wusb_df.o
-WUSB_FWMOD_OBJS += wusb_fwmod.o
-
 IPF_OBJS += ip_fil_solaris.o fil.o solaris.o ip_state.o ip_frag.o ip_nat.o \
 	    ip_proxy.o ip_auth.o ip_pool.o ip_htable.o ip_lookup.o \
 	    ip_log.o misc.o ip_compat.o ip_nat6.o drand48.o
--- old/usr/src/uts/common/Makefile.rules	Sun Apr 12 08:56:12 2015
+++ new/usr/src/uts/common/Makefile.rules	Sun Apr 12 08:56:12 2015
@@ -1185,10 +1185,6 @@
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
 
-$(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/usb/clients/hwarc/%.c
-	$(COMPILE.c) -o $@ $<
-	$(CTFCONVERT_O)
-
 $(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/usb/clients/hid/%.c
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
@@ -1237,18 +1233,6 @@
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
 
-$(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/usb/clients/wusb_df/%.c
-	$(COMPILE.c) -o $@ $<
-	$(CTFCONVERT_O)
-
-$(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/usb/clients/hwa1480_fw/%.c
-	$(COMPILE.c) -o $@ $<
-	$(CTFCONVERT_O)
-
-$(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/usb/clients/wusb_ca/%.c
-	$(COMPILE.c) -o $@ $<
-	$(CTFCONVERT_O)
-
 $(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/usb/clients/usbecm/%.c
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
@@ -1289,14 +1273,6 @@
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
 
-$(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/usb/hwa/hwahc/%.c
-	$(COMPILE.c) -o $@ $<
-	$(CTFCONVERT_O)
-
-$(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/uwb/uwba/%.c
-	$(COMPILE.c) -o $@ $<
-	$(CTFCONVERT_O)
-
 $(OBJS_DIR)/%.o:		$(UTSBASE)/common/io/vuidmice/%.c
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
@@ -2459,9 +2435,6 @@
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/video/usbvc/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/hwarc/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/hid/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
@@ -2498,15 +2471,6 @@
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/usbser/usbsprl/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/wusb_df/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/hwa1480_fw/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/wusb_ca/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/clients/usbecm/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
@@ -2537,12 +2501,6 @@
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/usba10/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/uwb/uwba/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
-$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/usb/hwa/hwahc/%.c
-	@($(LHEAD) $(LINT.c) $< $(LTAIL))
-
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/io/vuidmice/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
--- old/usr/src/uts/common/io/usb/usba/hubdi.c	Sun Apr 12 08:56:13 2015
+++ new/usr/src/uts/common/io/usb/usba/hubdi.c	Sun Apr 12 08:56:13 2015
@@ -597,11 +597,6 @@
 
 /*
  * hubd_get_soft_state() returns the hubd soft state
- *
- * WUSB support extends this function to support wire adapter class
- * devices. The hubd soft state for the wire adapter class device
- * would be stored in usb_root_hubd field of the usba_device structure,
- * just as the USB host controller drivers do.
  */
 hubd_t *
 hubd_get_soft_state(dev_info_t *dip)
@@ -611,7 +606,7 @@
 		return (NULL);
 	}
 
-	if (usba_is_root_hub(dip) || usba_is_wa(dip)) {
+	if (usba_is_root_hub(dip)) {
 		usba_device_t *usba_device = usba_get_usba_device(dip);
 
 		return (usba_device->usb_root_hubd);
@@ -6466,19 +6461,6 @@
 
 		rval = usba_destroy_child_devi(child_dip, flag);
 
-		if ((rval != USB_SUCCESS) && usba_is_hwa(child_dip)) {
-			/*
-			 * This is only useful for HWA device node.
-			 * Since hwahc interface must hold hwarc interface
-			 * open until hwahc is detached, the first call to
-			 * ndi_devi_unconfig_one() can only offline hwahc
-			 * driver but not hwarc driver. Need to make a second
-			 * call to ndi_devi_unconfig_one() to make the hwarc
-			 * driver detach.
-			 */
-			rval = usba_destroy_child_devi(child_dip, flag);
-		}
-
 		if ((rval == USB_SUCCESS) && (flag & NDI_DEVI_REMOVE)) {
 			/*
 			 * if the child was still < DS_INITIALIZED
--- old/usr/src/uts/common/io/usb/usba/parser.c	Sun Apr 12 08:56:13 2015
+++ new/usr/src/uts/common/io/usb/usba/parser.c	Sun Apr 12 08:56:13 2015
@@ -21,6 +21,8 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 
@@ -620,63 +622,4 @@
 	}
 
 	return (USB_PARSE_ERROR);
-}
-
-size_t
-usb_parse_bos_descr(uchar_t	*buf,	/* from GET_DESCRIPTOR(BOS) */
-	size_t			buflen,
-	usb_bos_descr_t		*ret_descr,
-	size_t			ret_buf_len)
-{
-	if ((buf == NULL) || (ret_descr == NULL) ||
-	    (buflen < 2) || (buf[1] != USB_DESCR_TYPE_BOS)) {
-
-		return (USB_PARSE_ERROR);
-	}
-
-	return (usb_parse_data("ccsc",
-	    buf, buflen, ret_descr, ret_buf_len));
-}
-
-size_t
-usb_parse_uwb_bos_descr(uchar_t	*buf,	/* from GET_DESCRIPTOR(BOS) */
-	size_t			buflen,
-	usb_uwb_cap_descr_t	*ret_descr,
-	size_t			ret_buf_len)
-{
-	uchar_t *bufend = buf + buflen;
-
-	if ((buf == NULL) || (ret_descr == NULL)) {
-
-		return (USB_PARSE_ERROR);
-	}
-
-	while (buf + 3 <= bufend) {
-		if ((buf[1] == USB_DESCR_TYPE_DEV_CAPABILITY) &&
-		    (buf[2] == USB_CAP_TYPE_WUSB)) {
-
-			return (usb_parse_data("ccccsccsc",
-			    buf, _PTRDIFF(bufend, buf), ret_descr,
-			    ret_buf_len));
-		}
-
-		INCREMENT_BUF(buf);
-	}
-
-	return (USB_PARSE_ERROR);
-}
-
-size_t
-usb_parse_comp_ep_descr(uchar_t	*buf,	/* from GET_DESCRIPTOR(CONFIGURATION) */
-	size_t			buflen,
-	uint_t			if_number,
-	uint_t			alt_if_setting,
-	uint_t			ep_index,
-	usb_ep_comp_descr_t	*ret_descr,
-	size_t			ret_buf_len)
-{
-	return (usb_parse_CV_ep_descr(buf, buflen, "ccccsscc",
-	    if_number, alt_if_setting, ep_index,
-	    USB_DESCR_TYPE_WIRELESS_EP_COMP, 0,
-	    ret_descr, ret_buf_len));
 }
--- old/usr/src/uts/common/io/usb/usba/usba.c	Sun Apr 12 08:56:14 2015
+++ new/usr/src/uts/common/io/usb/usba/usba.c	Sun Apr 12 08:56:14 2015
@@ -21,6 +21,8 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 
@@ -119,12 +121,10 @@
 	usba_usbai_register_initialization();
 	usba_hcdi_initialization();
 	usba_hubdi_initialization();
-	usba_whcdi_initialization();
 	usba_devdb_initialization();
 
 	if ((rval = mod_install(&modlinkage)) != 0) {
 		usba_devdb_destroy();
-		usba_whcdi_destroy();
 		usba_hubdi_destroy();
 		usba_hcdi_destroy();
 		usba_usbai_register_destroy();
@@ -142,7 +142,6 @@
 
 	if ((rval = mod_remove(&modlinkage)) == 0) {
 		usba_devdb_destroy();
-		usba_whcdi_destroy();
 		usba_hubdi_destroy();
 		usba_hcdi_destroy();
 		usba_usbai_register_destroy();
@@ -641,26 +640,6 @@
 
 
 /*
- * free wireless usb specific structure
- */
-void
-usba_free_wireless_data(usba_wireless_data_t *wireless_data)
-{
-	if (wireless_data == NULL) {
-
-		return;
-	}
-
-	if (wireless_data->wusb_bos) {
-		kmem_free(wireless_data->wusb_bos,
-		    wireless_data->wusb_bos_length);
-	}
-
-	kmem_free(wireless_data, sizeof (usba_wireless_data_t));
-}
-
-
-/*
  * free usb device structure
  */
 void
@@ -788,22 +767,7 @@
 			    strlen(usba_device->usb_serialno_str) + 1);
 		}
 
-		if (usba_device->usb_wireless_data) {
-			mutex_enter(&usba_device->usb_mutex);
-			usba_free_wireless_data(
-			    usba_device->usb_wireless_data);
-			mutex_exit(&usba_device->usb_mutex);
-		}
-
-		/*
-		 * The device address on the wireless bus is assigned
-		 * by the wireless host controller driver(whci or hwahc),
-		 * not by USBA framework, so skip this for wireless
-		 * USB devices.
-		 */
-		if (!usba_device->usb_is_wireless) {
-			usba_unset_usb_address(usba_device);
-		}
+		usba_unset_usb_address(usba_device);
 	}
 
 #ifndef __lock_lint
@@ -1429,52 +1393,6 @@
 	mutex_exit(&usba_hub_mutex);
 
 	return (0);
-}
-
-/*
- * check whether this dip is a wire adapter device
- */
-int
-usba_is_wa(dev_info_t *dip)
-{
-	if (dip) {
-		usba_device_t *usba_device;
-
-		usba_device = usba_get_usba_device(dip);
-
-		return (usba_device->usb_is_wa? 1:0);
-	}
-
-	return (0);
-}
-
-/*
- * check whether this dip is a host wire adapter device node
- */
-int
-usba_is_hwa(dev_info_t *dip)
-{
-	dev_info_t	*cdip;
-
-	if (dip == NULL) {
-
-		return (0);
-	}
-
-	if (strcmp(ddi_driver_name(dip), "usb_mid") != 0) {
-
-		return (0);
-	}
-
-	for (cdip = ddi_get_child(dip); cdip;
-	    cdip = ddi_get_next_sibling(cdip)) {
-		if (strcmp(ddi_driver_name(cdip), "hwarc") == 0) {
-
-			return (1);
-		}
-	}
-
-	return (0);
 }
 
 /*
--- old/usr/src/uts/common/io/usb/usba/usbai_pipe_mgmt.c	Sun Apr 12 08:56:14 2015
+++ new/usr/src/uts/common/io/usb/usba/usbai_pipe_mgmt.c	Sun Apr 12 08:56:14 2015
@@ -21,6 +21,8 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 
@@ -523,14 +525,6 @@
 		uint16_t	maxpktsize;
 
 		maxpktsize = usba_device->usb_dev_descr->bMaxPacketSize0;
-		if (usba_device->usb_is_wireless) {
-			/*
-			 * according to wusb 1.0 spec 4.8.1, the host must
-			 * assume a wMaxPacketSize of 512 for the default
-			 * control pipe of a wusb device
-			 */
-			maxpktsize = 0x200;
-		}
 		USB_DPRINTF_L3(DPRINT_MASK_USBAI, usbai_log_handle,
 		    "adjusting max packet size from %d to %d",
 		    ph_data->p_ep.wMaxPacketSize, maxpktsize);
--- old/usr/src/uts/common/io/usb/usba/usbai_register.c	Sun Apr 12 08:56:14 2015
+++ new/usr/src/uts/common/io/usb/usba/usbai_register.c	Sun Apr 12 08:56:14 2015
@@ -21,6 +21,8 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 /*
@@ -112,7 +114,6 @@
 uint_t			usbai_register_errmask = (uint_t)-1;
 
 /* Function prototypes */
-static int usba_build_bos(usba_device_t *, usb_client_dev_data_t *);
 static int usba_build_descr_tree(dev_info_t *, usba_device_t *,
 				usb_client_dev_data_t *);
 static void usba_process_cfg_descr(usba_reg_state_t *);
@@ -119,7 +120,6 @@
 static int usba_process_if_descr(usba_reg_state_t *, boolean_t *);
 static int usba_process_ep_descr(usba_reg_state_t *);
 static int usba_process_cv_descr(usba_reg_state_t *);
-static int usba_process_ep_comp_descr(usba_reg_state_t *);
 static int usba_set_parse_values(dev_info_t *dip, usba_device_t *usba_device,
     usba_reg_state_t *state);
 static void* usba_kmem_realloc(void *, int, int);
@@ -427,16 +427,6 @@
 		return (USB_FAILURE);
 	}
 
-	/* get parsed bos for wusb device */
-	if (usba_device->usb_is_wireless) {
-		if ((rval = usba_build_bos(usba_device, usb_reg)) !=
-		    USB_SUCCESS) {
-			kmem_free(usb_reg, sizeof (usb_client_dev_data_t));
-
-			return (rval);
-		}
-	}
-
 	usb_reg->dev_iblock_cookie = usba_hcdi_get_hcdi(
 	    usba_device->usb_root_hub_dip)->hcdi_soft_iblock_cookie;
 
@@ -595,10 +585,6 @@
 			usb_free_descr_tree(dip, reg);
 		}
 
-		if (reg->dev_bos != NULL) {
-			kmem_free(reg->dev_bos, sizeof (usb_bos_data_t));
-		}
-
 		mutex_enter(&usba_device->usb_mutex);
 		prev = &usba_device->usb_client_dev_data_list;
 		entry = usba_device->usb_client_dev_data_list.cddl_next;
@@ -647,40 +633,6 @@
 }
 
 /*
- * This builds the BOS descriptors for WUSB device
- */
-static int
-usba_build_bos(usba_device_t *usba_device, usb_client_dev_data_t *usb_reg)
-{
-	uint8_t		*buf;
-	size_t		size, buflen;
-
-	buf = usba_device->usb_wireless_data->wusb_bos;
-	buflen = usba_device->usb_wireless_data->wusb_bos_length;
-
-	usb_reg->dev_bos = kmem_zalloc(sizeof (usb_bos_data_t),
-	    KM_SLEEP);
-	size = usb_parse_bos_descr(buf, buflen, &usb_reg->dev_bos->bos_descr,
-	    sizeof (usb_bos_descr_t));
-	if (size != USB_BOS_DESCR_SIZE) {
-		kmem_free(usb_reg->dev_bos, sizeof (usb_bos_data_t));
-
-		return (USB_FAILURE);
-	}
-
-	size = usb_parse_uwb_bos_descr(buf, buflen,
-	    &usb_reg->dev_bos->bos_uwb_cap, sizeof (usb_uwb_cap_descr_t));
-	if (size != USB_UWB_CAP_DESCR_SIZE) {
-		kmem_free(usb_reg->dev_bos, sizeof (usb_bos_data_t));
-
-		return (USB_FAILURE);
-	}
-
-	return (USB_SUCCESS);
-}
-
-
-/*
  * usba_build_descr_tree:
  *	This builds the descriptor tree.  See module header comment for tree
  *	description.
@@ -847,18 +799,6 @@
 				}
 
 				break;
-			case USB_DESCR_TYPE_WIRELESS_EP_COMP:
-				/* for WUSB devices */
-				if (process_this_if_tree &&
-				    state.st_build_ep_comp) {
-					if (usba_process_ep_comp_descr(
-					    &state) != USB_SUCCESS) {
-
-						return (USB_FAILURE);
-					}
-				}
-
-				break;
 			case USB_DESCR_TYPE_STRING:
 				USB_DPRINTF_L2(DPRINT_MASK_ALL,
 				    usbai_reg_log_handle,
@@ -1107,30 +1047,6 @@
 }
 
 
-static int
-usba_process_ep_comp_descr(usba_reg_state_t *state)
-{
-	USB_DPRINTF_L4(DPRINT_MASK_REGISTER, usbai_reg_log_handle,
-	    "usba_process_ep_comp_descr starting");
-
-	/* No endpoint descr preceeds this descr */
-	if (state->st_curr_ep == NULL) {
-		USB_DPRINTF_L2(DPRINT_MASK_REGISTER, usbai_reg_log_handle,
-		    "usba_process_ep_comp_descr: no endpt before the descr");
-
-		return (USB_FAILURE);
-	}
-
-	(void) usb_parse_data("ccccsscc", state->st_curr_raw_descr,
-	    state->st_curr_raw_descr_len,
-	    &state->st_curr_ep->ep_comp_descr,
-	    sizeof (usb_ep_comp_descr_t));
-	USB_DPRINTF_L4(DPRINT_MASK_REGISTER, usbai_reg_log_handle,
-	    "usba_process_ep_comp_descr done");
-
-	return (USB_SUCCESS);
-}
-
 /*
  * usba_process_cv_descr:
  *	This processes a raw endpoint descriptor, and sets up an analogous
@@ -1227,7 +1143,6 @@
 	/* Default to *all* in case configuration# prop not set. */
 	mutex_enter(&usba_device->usb_mutex);
 	state->st_cfg_to_build = usba_device->usb_active_cfg_ndx;
-	state->st_build_ep_comp = usba_device->usb_is_wireless;
 	mutex_exit(&usba_device->usb_mutex);
 	if (state->st_cfg_to_build == USBA_DEV_CONFIG_INDEX_UNDEFINED) {
 		state->st_cfg_to_build = USBA_ALL;
--- old/usr/src/uts/common/sys/Makefile	Sun Apr 12 08:56:15 2015
+++ new/usr/src/uts/common/sys/Makefile	Sun Apr 12 08:56:15 2015
@@ -1011,13 +1011,6 @@
 	usba.h	\
 	usbai.h
 
-UWBHDRS=	\
-	uwb.h	\
-	uwbai.h
-
-UWBAHDRS=	\
-	uwba.h
-
 USBAUDHDRS=           \
 	usb_audio.h
 
@@ -1028,9 +1021,6 @@
 USBHIDHDRS=		\
 	hid.h
 
-USBHWARCHDRS=		\
-	hwarc.h
-
 USBMSHDRS=		\
 	usb_bulkonly.h	\
 	usb_cbi.h
@@ -1199,7 +1189,6 @@
 	$(USBAUDHDRS:%.h=usb/clients/audio/%.check)   \
 	$(USBHUBDHDRS:%.h=usb/hubd/%.check)		\
 	$(USBHIDHDRS:%.h=usb/clients/hid/%.check)	\
-	$(USBHWARCHDRS:%.h=usb/clients/hwarc/%.check)	\
 	$(USBMSHDRS:%.h=usb/clients/mass_storage/%.check)	\
 	$(USBPRNHDRS:%.h=usb/clients/printer/%.check)   \
 	$(USBCDCHDRS:%.h=usb/clients/usbcdc/%.check)	\
@@ -1207,8 +1196,6 @@
 	$(USBWCMHDRS:%.h=usb/clients/usbinput/usbwcm/%.check)	\
 	$(UGENHDRS:%.h=usb/clients/ugen/%.check)   \
 	$(USBHDRS:%.h=usb/%.check)                      \
-	$(UWBHDRS:%.h=uwb/%.check)                      \
-	$(UWBAHDRS:%.h=uwb/uwba/%.check)                      \
 	$(I1394HDRS:%.h=1394/%.check)			\
 	$(RSMHDRS:%.h=rsm/%.check)			\
 	$(TSOLHDRS:%.h=tsol/%.check)			\
--- old/usr/src/uts/common/sys/Makefile.syshdrs	Sun Apr 12 08:56:15 2015
+++ new/usr/src/uts/common/sys/Makefile.syshdrs	Sun Apr 12 08:56:15 2015
@@ -19,7 +19,7 @@
 # CDDL HEADER END
 #
 # Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
-# Copyright 2013 Garrett D'Amore <garrett@damore.org>
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 # Common definitions for open and closed headers.
@@ -143,9 +143,6 @@
 usb/clients/hid/%.check:	usb/clients/hid/%.h
 	$(DOT_H_CHECK)
 
-usb/clients/hwarc/%.check:	usb/clients/hwarc/%.h
-	$(DOT_H_CHECK)
-
 usb/clients/mass_storage/%.check:	usb/clients/mass_storage/%.h
 	$(DOT_H_CHECK)
 
@@ -229,7 +226,6 @@
 	$(ROOTDIR)/usb/clients	\
 	$(ROOTDIR)/usb/clients/audio  \
 	$(ROOTDIR)/usb/clients/hid \
-	$(ROOTDIR)/usb/clients/hwarc \
 	$(ROOTDIR)/usb/clients/mass_storage	\
 	$(ROOTDIR)/usb/clients/printer  \
 	$(ROOTDIR)/usb/clients/usbcdc  \
@@ -236,8 +232,6 @@
 	$(ROOTDIR)/usb/clients/video/usbvc  \
 	$(ROOTDIR)/usb/clients/usbinput/usbwcm \
 	$(ROOTDIR)/usb/clients/ugen  \
-	$(ROOTDIR)/uwb \
-	$(ROOTDIR)/uwb/uwba \
 	$(ROOTDIR)/1394         \
 	$(ROOTDIR)/rsm		\
 	$(ROOTDIR)/tsol		\
@@ -311,12 +305,9 @@
 ROOTXHDRS= $(XHDRS:%=$(ROOTDIR)/%)
 
 ROOTUSBHDRS= $(USBHDRS:%=$(ROOTDIR)/usb/%)
-ROOTUWBHDRS= $(UWBHDRS:%=$(ROOTDIR)/uwb/%)
-ROOTUWBAHDRS= $(UWBAHDRS:%=$(ROOTDIR)/uwb/uwba/%)
 ROOTUSBAUDHDRS= $(USBAUDHDRS:%=$(ROOTDIR)/usb/clients/audio/%)
 ROOTUSBHUBDHDRS= $(USBHUBDHDRS:%=$(ROOTDIR)/usb/hubd/%)
 ROOTUSBHIDHDRS = $(USBHIDHDRS:%=$(ROOTDIR)/usb/clients/hid/%)
-ROOTUSBHWARCHDRS = $(USBHWARCHDRS:%=$(ROOTDIR)/usb/clients/hwarc/%)
 ROOTUSBMSHDRS= $(USBMSHDRS:%=$(ROOTDIR)/usb/clients/mass_storage/%)
 ROOTUSBPRNHDRS= $(USBPRNHDRS:%=$(ROOTDIR)/usb/clients/printer/%)
 ROOTUSBCDCHDRS= $(USBCDCHDRS:%=$(ROOTDIR)/usb/clients/usbcdc/%)
@@ -339,13 +330,11 @@
 sparc_ROOTHDRS=	$(ROOTSDKTPHDRS) $(ROOTSCSICADHDRS) $(ROOTSCSITARGETSHDRS) \
 		$(ROOTUSBHDRS) $(ROOTUSBHUBDHDRS) \
 		$(ROOTUSBAUDHDRS) $(ROOTUSBHIDHDRS) $(ROOTUSBMSHDRS) \
-		$(ROOTUSBPRNHDRS) $(ROOTUGENHDRS) $(ROOTUSBVIDHDRS) \
-		$(ROOTUWBHDRS) $(ROOTUWBAHDRS) $(ROOTUSBHWARCHDRS)
+		$(ROOTUSBPRNHDRS) $(ROOTUGENHDRS) $(ROOTUSBVIDHDRS)
 
 i386_ROOTHDRS=	$(ROOTDKTPHDRS) $(ROOTPCHDRS) $(ROOTSCSITARGETSHDRS)	\
 		$(ROOTSCSIVHCIHDRS) $(ROOTHOTPLUGHDRS) \
-		$(ROOTHOTPLUGPCIHDRS) $(ROOTSATAGENHDRS) \
-		$(ROOTUWBHDRS) $(ROOTUWBAHDRS) $(ROOTUSBHWARCHDRS)
+		$(ROOTHOTPLUGPCIHDRS) $(ROOTSATAGENHDRS)
 
 # install rules
 $(ROOTDIR)/%: %
--- old/usr/src/uts/common/sys/usb/usba/usba_impl.h	Sun Apr 12 08:56:16 2015
+++ new/usr/src/uts/common/sys/usb/usba/usba_impl.h	Sun Apr 12 08:56:16 2015
@@ -21,6 +21,8 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 #ifndef	_SYS_USB_USBA_USBA_IMPL_H
@@ -265,15 +267,9 @@
 int	usba_hubdi_register(dev_info_t	*, uint_t);
 int	usba_hubdi_unregister(dev_info_t *);
 
-void	usba_whcdi_initialization();
-void	usba_whcdi_destroy();
-
 int	usba_is_root_hub(dev_info_t *dip);
-int	usba_is_wa(dev_info_t *dip);
-int	usba_is_hwa(dev_info_t *dip);
 
 usba_device_t *usba_alloc_usba_device(dev_info_t *);
-void	usba_free_wireless_data(usba_wireless_data_t *wireless_data);
 void	usba_free_usba_device(usba_device_t *usba_device_t);
 void	usba_clear_data_toggle(usba_device_t *usba_device);
 
